#!/bin/bash
source ~/.shell/lib/test.bash

given  . ~/.shell/lib/shared.sh
when   has this-command-should-definitely-not-exist
expect no_output
expect [[ $RETVAL -eq 1 ]]


given  . ~/.shell/lib/shared.sh
when   has bash
expect no_output
expect [[ $RETVAL -eq 0 ]]

given  . ~/.shell/lib/shared.sh
when   has bash is function
expect no_output
expect [[ $RETVAL -eq 1 ]]

given  . ~/.shell/lib/shared.sh
when   has bash is file
expect no_output
expect [[ $RETVAL -eq 0 ]]

given  . ~/.shell/lib/shared.sh
when   has bash is $BASH
expect no_output
expect [[ $RETVAL -eq 0 ]]

given  . ~/.shell/lib/shared.sh
when   has bash is /bin/ls
expect no_output
expect [[ $RETVAL -eq 1 ]]

given  . ~/.shell/lib/shared.sh
when   has bash is /bin/ls
expect no_output
expect [[ $RETVAL -eq 1 ]]

given  . ~/.shell/lib/shared.sh
when   has bash is-not /bin/ls
expect no_output
expect [[ $RETVAL -eq 0 ]]


given  . ~/.shell/lib/shared.sh
when   has type
expect no_output
expect [[ $RETVAL -eq 0 ]]

given  . ~/.shell/lib/shared.sh
when   has type is builtin
expect no_output
expect [[ $RETVAL -eq 0 ]]

given  . ~/.shell/lib/shared.sh
when   has type is file
expect no_output
expect [[ $RETVAL -eq 1 ]]

given  . ~/.shell/lib/shared.sh
when   has type is function
expect no_output
expect [[ $RETVAL -eq 1 ]]


given  . ~/.shell/lib/shared.sh
given  "foo() { :; }"
when   has foo is function
expect no_output
expect [[ $RETVAL -eq 0 ]]
