. ~/.shell/lib/shared.sh

has splitpaths || return


_venv_glob_path() (
	local dir pattern
	case $CURRENT_SHELL in
		bash) shopt -u failglob; shopt -s nullglob extglob ;;
		zsh) setopt nullglob extendedglob badpattern ;;
	esac
	splitpaths "$PATH" | while read -r dir; do
		for pattern in "$@"; do
			eval "printf '%s\n' '$dir'/$pattern"
		done
	done
)


_venv_make_func() {
	local pattern python version
	local platform=`uname -s | tr A-Z a-z`-`uname -m`
	case $CURRENT_SHELL in
		zsh) pattern='python<3->(.<->)#' ;;
		*) pattern='python@([3-9]|[0-9]+([0-9]))?(.+([0-9]))' ;;
	esac
	for python in $(_venv_glob_path "$pattern"|basename_filter|sort -u); do
		version=$(tr -d . <<<"${python#python}")
		alias pydevenv${version}="_venv_enable $version $platform $(which $python)"
	done
}


_venv_enable() {
	local venv=.venv${1}-${2} python=$3
	[[ -f "$venv/bin/activate" ]] || $python -m venv "$venv"
	[[ -x "$venv/bin/$(basename $python)" ]] || $python -m venv --upgrade "$venv"
	[[ -v VIRTUAL_ENV ]] && has deactivate is function && deactivate
	source "$venv/bin/activate"
	export CONTEXT_PY=$1
}


_venv_make_func
