#!/bin/sh
exec 2>&1
set -eu

new_session()
{
	tmux new-session -ds "$1"
	tmux link-window -dk -s General:0 -t "$1":0
	tmux switch-client -t "$1"
}

quit_session()
{
	local session=$1
	local clients="`tmux list-clients -t "$session" -F '#{client_tty}'`"
	local client=
	for client in $clients; do
		tmux switch-client -n -t $client
	done
	tmux kill-session -t "$session"
}

action=$1
shift
case $action in
	new) new_session "$*" ;;
	quit) quit_session "$*" ;;
	*) exit 2 ;;
esac
